-- Test Vector Generation in VHDL
-- Generated by WaveFormer Lite Version 8.9  
library ieee, std;
-- Libraries used by model under test
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
-- End of libraries used by model under test

entity stimulus is
  port(
      SRAM_DATA		: inout std_logic_vector(7 downto 0);
      WR_addr		: out std_logic_vector(6 downto 0);
      RD_addr		: in std_logic_vector(6 downto 0);
      WR_EN		: out std_logic;
      RD_EN		: out std_logic;
      Aclr		: out std_logic;
      WClock		: out std_logic;
      RClock		: out std_logic
      
      );
end stimulus;

architecture GeneratedCode of stimulus is
begin

WClock_process : process
  variable tb_stop_time : time := 1059 ns;
  variable WClock_Offset : time := 0 ns;
  variable WClock_Period : time := 20 ns;
  variable WClock_MinLH : time := 0 ns;
  variable WClock_MaxLH : time := 0 ns;
  variable WClock_MinHL : time := 0 ns;
  variable WClock_MaxHL : time := 0 ns;
  variable WClock_JRise : time := 0 ns;
  variable WClock_JFall : time := 0 ns;
  variable WClock_Duty : time := 50 ns;
  variable WClock_high : time;
  variable WClock_low : time;
begin 
  WClock_high := WClock_Period * (WClock_Duty / ns) / 100;
  WClock_low := WClock_Period - WClock_high;
  WClock <= '0';
  if (WClock_Offset + (WClock_MinLH - WClock_JRise/2) < 0 ns) then
    assert FALSE report "Clock offset is less than 0 for WClock. This could be caused by jitter. Increase offset to get rid of this error." severity FAILURE;
  else
    wait for WClock_Offset + (WClock_MinLH - WClock_JRise/2);
    while (now < tb_stop_time) loop
      WClock <= '1';
      wait for (WClock_high - (WClock_MaxLH + WClock_JRise/2) + (WClock_MinHL - WClock_JFall/2));
      WClock <= '0';
      wait for (WClock_low - (WClock_MaxHL + WClock_JFall/2) + (WClock_MinLH - WClock_JRise/2));
    end loop;
  end if;
 
end process;

RClock_process : process
  variable tb_stop_time : time := 1059 ns;
  variable RClock_Offset : time := 0 ns;
  variable RClock_Period : time := 40 ns;
  variable RClock_MinLH : time := 0 ns;
  variable RClock_MaxLH : time := 0 ns;
  variable RClock_MinHL : time := 0 ns;
  variable RClock_MaxHL : time := 0 ns;
  variable RClock_JRise : time := 0 ns;
  variable RClock_JFall : time := 0 ns;
  variable RClock_Duty : time := 50 ns;
  variable RClock_high : time;
  variable RClock_low : time;
begin 
  RClock_high := RClock_Period * (RClock_Duty / ns) / 100;
  RClock_low := RClock_Period - RClock_high;
  RClock <= '0';
  if (RClock_Offset + (RClock_MinLH - RClock_JRise/2) < 0 ns) then
    assert FALSE report "Clock offset is less than 0 for RClock. This could be caused by jitter. Increase offset to get rid of this error." severity FAILURE;
  else
    wait for RClock_Offset + (RClock_MinLH - RClock_JRise/2);
    while (now < tb_stop_time) loop
      RClock <= '1';
      wait for (RClock_high - (RClock_MaxLH + RClock_JRise/2) + (RClock_MinHL - RClock_JFall/2));
      RClock <= '0';
      wait for (RClock_low - (RClock_MaxHL + RClock_JFall/2) + (RClock_MinLH - RClock_JRise/2));
    end loop;
  end if;
end process;

  process
  begin
    SRAM_DATA <=
      transport x"01",
                x"02" after 81 ns,
                x"03" after 115 ns,
                x"04" after 154 ns,
                x"05" after 181 ns,
                x"06" after 212 ns,
                x"07" after 239 ns,
                x"08" after 270 ns,
                x"09" after 295 ns,
                x"0A" after 326 ns,
                x"0B" after 356 ns,
                x"0C" after 390 ns,
                "ZZZZZZZZ" after 436 ns;
    WR_addr <=
      transport "0000000",
                "0000001" after 81 ns,
                "0000010" after 115 ns,
                "0000011" after 155 ns,
                "0000100" after 181 ns,
                "0000101" after 213 ns,
                "0000110" after 240 ns,
                "0000111" after 270 ns,
                "0001000" after 295 ns,
                "0001001" after 327 ns,
                "0010000" after 356 ns,
                "0010001" after 392 ns;
    WR_EN <=
      transport '1',
                '0' after 38 ns,
                '1' after 440 ns;
    RD_EN <=
      transport '1',
                '0' after 479 ns;
    Aclr <=
      transport '0',
                '1' after 23 ns;
    wait;
  end process;

end GeneratedCode;

--Top Level Test Bench Module
  -- Contains an instance of the Stimulus Module and an instance of the Product Module
library std;
use std.textio.all;
library ieee, std;
-- Libraries used by model under test
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
-- End of libraries used by model under test

use work.all;

entity testbench is
  end testbench;

architecture tbGeneratedCode of testbench is
   -- Component declaration for the stimulus module
   component stimulus
    port(
      SRAM_DATA		: inout std_logic_vector(7 downto 0);
      WR_addr		: out std_logic_vector(6 downto 0);
      RD_addr		: in std_logic_vector(6 downto 0);
      WR_EN		: out std_logic;
      RD_EN		: out std_logic;
      Aclr		: out std_logic;
      WClock		: out std_logic;
      RClock		: out std_logic
      );
   end component;

   -- Component declaration for the product module
   component top
    port(
      SRAM_DATA	 : inout	 std_logic_vector(7 downto 0);
      WR_addr	 : in	 std_logic_vector(6 downto 0);
      RD_addr	 : out	 std_logic_vector(6 downto 0);
      WR_EN	 : in	 std_logic;
      RD_EN	 : in	 std_logic;
      Aclr	 : in	 std_logic;
      WClock	 : in	 std_logic;
      RClock	 : in	 std_logic
        );
   end component;
   -- Signal Declarations for the test bench module
    signal		SRAM_DATA			: std_logic_vector(7 downto 0);
    signal		WR_addr			: std_logic_vector(6 downto 0);
    signal		RD_addr			: std_logic_vector(6 downto 0);
    signal		WR_EN			: std_logic;
    signal		RD_EN			: std_logic;
    signal		Aclr			: std_logic;
    signal		WClock			: std_logic;
    signal		RClock			: std_logic;
    signal              check_clock             : std_logic;    
   -- Vector File Open
   file TestFile: text open write_mode is "Test_Vectors.txt";
   
   -- Function Definition for Format Conversion
   
   function IN_VAL(v:std_logic_vector) return string is
   
   variable temp_string: string(1 to v'length);
   variable vl : natural := v'length;
   begin
   
   	for i in v'range loop
   		if (v(i) ='1') or (v(i)='H') then
   			temp_string(vl-i) := '1';
   		elsif (v(i)='0') or (v(i)='L') then
   			temp_string(vl-i) := '0';
      		elsif (v(i)='Z') then
   			temp_string(vl-i) := 'Z';
   		else
   			temp_string(vl-i) := 'X';
   		end if;
   	end loop;
   	return(temp_string);
   end function IN_VAL;
      
   
   
   function OUT_VAL(v:std_logic_vector) return string is
   
   variable temp_string: string(1 to v'length);
   variable vl : natural := v'length;
   begin
   	for i in v'range loop
   		if (v(i) ='1') or (v(i)='H') then
   			temp_string(vl-i) := 'H';
   		elsif (v(i)='0') or (v(i)='L') then
   			temp_string(vl-i) := 'L';
     		elsif (v(i)='Z') then
   			temp_string(vl-i) := 'Z';
   		else
   			temp_string(vl-i) :=  'X';
   	end if;
   	end loop;
   	return(temp_string);
end function OUT_VAL;

-- Vectors to temoprarily store inputs, ouputs and bidirectionals   
signal input_vector	: std_logic_vector(11 downto 0);	
signal bidir_vector	: std_logic_vector(7 downto 0);
signal output_vector	: std_logic_vector(6 downto 0);


  
-- Ports are connected by matching the port names of the Test Module
   begin
     stimulus_0: stimulus
       port map(
                  SRAM_DATA,
                  WR_addr,
                  RD_addr,
                  WR_EN,
                  RD_EN,
                  Aclr,
                  WClock,
                  RClock
                  
                  );
    top_0 : top
      port map(
                  SRAM_DATA => SRAM_DATA,
                  WR_addr => WR_addr,
                  RD_addr => RD_addr,
                  WR_EN => WR_EN,
                  RD_EN => RD_EN,
                  Aclr => Aclr,
                  WClock => WClock,
                  RClock => RClock
                  );
                  

-- defining the virtual check clock for output sampling
check_clock <= WClock after 8 ns;

-- loading the temp storage vectors
process (WClock)
begin
if (rising_edge (WClock) or falling_edge (WClock)) then
input_vector <= WClock & RClock & WR_EN & RD_EN & Aclr & WR_addr;
end if;

end process;

output_vector <= RD_addr;
bidir_vector <= SRAM_DATA;


-- process of sampling the outputs and writing the vector file
test_vector: process (check_clock)
variable line_ind: line;

begin
if (rising_edge(check_clock) or falling_edge(check_clock)) then
		write(line_ind,IN_VAL(input_vector));
		write(line_ind,string'("    "));
		if (WR_EN = '1') then
		   if (RD_EN = '0') then
		   	write(line_ind,OUT_VAL(bidir_vector));
		   else
			write(line_ind,IN_VAL(bidir_vector));
		   end if;
		else
		write(line_ind,IN_VAL(bidir_vector));
		end if;
		write(line_ind,string'("    "));
		write(line_ind,OUT_VAL(output_vector));   
		writeline(TestFile,line_ind);
             
end if;


end process test_vector;

end tbGeneratedCode;

